#include "itext.h"
#include "xtext.h"
#include "xjp.h"
#include <stdarg.h>

extern int opterr; 
extern int optind; 
extern char *optarg;
extern int getopt(int argc,char * const * argv,const char * pattern);

static void _usage()
{
	fprintf(stderr,"\n");
	fprintf(stderr,"    %s  Version : %s\n\n",XTEXT_NAME,XTEXT_VERSION);
	fprintf(stderr," E_MAIL : %s\n",XTEXT_EMAIL);
	fprintf(stderr,"HOMEPAGE: %s\n\n\n",XTEXT_HOMEPAGE);
	fprintf(stderr,"Usage:	xjp [option] (-f file_path)\n\n");
	fprintf(stderr,"[option]\n");
	fprintf(stderr,	
"   -h       Help Message (This Message)\n \
  -d <dir>   Book Directory\n \
  -f <file>  Book(.txt|.zip) Path\n \
  -a <num>   Window Width\n \
  -b <num>   Window Height\n \
  -c <str>   Main Window-Color (X11 Color_Name)\n \
  -e <str>   Main Font-Color (X11 Color_Name)\n \
  -g <str>   Ruby Font-Color (X11 Color_Name)\n \
  -i <str>   Message Font-Color (X11 Color_Name)\n \
  -j <str>   Message Window-Color (X11 Color_Name)\n \
  -k <str>   Main Font_Name (Xlfd format)\n \
  -l <str>   Sub Font_Name (Xlfd format)\n \
  -m <str>   1Byte Font_Name (xlfd format)\n \
  -n <str>   Ruby Font_Name (xlfd format)\n \
  -o         Use Xft (0?1)\n \
  -p <num>   Line Space (Pixel)\n \
  -q <num>   Row Space (Pixel)\n \
  -r         Display Book_Title (0?1)\n \
  -s	     Display Page_No (0?1) \n \
  -t	     Display Ruby_Char (0?1) \n \
  -u <path>  Rast-Data-Base Path \n \
					 ");
	fprintf(stderr,"\n");
	exit(1);
}	
char * xtext_get_option(int c,char **v,xtext_conf_t *xconf)
{
	int option;

	while(1){
		if((option = getopt(c,v,"a:b:c:d:e:f:g:i:j:k:l:m:n:p:q:u:o:r:s:t:h")) == -1) break;
		switch(option){
			case 'h': _usage(); break;
			case 'f':return optarg;break;
			case 'd':_xconf_malloc(xconf->book_dir,128,optarg);break;
			case 'a':xconf->main_window_width = atoi(optarg);break;
			case 'b':xconf->main_window_height = atoi(optarg);break;
			case 'c':_xconf_malloc(xconf->main_window_color,64,optarg);break;
			case 'e':_xconf_malloc(xconf->main_font_color,64,optarg);break;
			case 'g':_xconf_malloc(xconf->rubi_font_color,64,optarg);break;
			case 'i':_xconf_malloc(xconf->menu_font_color,64,optarg);break;
			case 'j':_xconf_malloc(xconf->menu_window_color,64,optarg);break;
			case 'k':_xconf_malloc(xconf->main_font_j,128,optarg);break;
			case 'l':_xconf_malloc(xconf->main_font_s,128,optarg);break;
			case 'm':_xconf_malloc(xconf->main_font_e,128,optarg);break;
			case 'n':_xconf_malloc(xconf->rubi_font,128,optarg);break;
			case 'o':xconf->anti = atoi(optarg);break;
			case 'p':xconf->line_space = atoi(optarg);break;
			case 'q':xconf->row_space = atoi(optarg);break;
			case 'r':xconf->title_on = atoi(optarg);break;
			case 's':xconf->page_on = atoi(optarg);break;
			case 't':xconf->ruby_on = atoi(optarg);break;
			case 'u':_xconf_malloc(xconf->rast_db,128,optarg);break;

			default: _usage(); break;
		}
	}
	return NULL;
}
int xtext_create_offsetFile(char *filename)
{
	FILE *fp;

	unsigned char it[3];
	long j;
	int i;

        char *title = "\
\
# Ĵե\n\
#\n\
# ʸɤϡEUCǤե¸EUCλ\n\
# ʲоʸ[-7  +7 ԥ] ϰϤĴǽǤ\n\
#\n\
# {\"оʸ\",\"1Х\",\"2Х\",\"xĴ\",\"yĴ\"}\n\
\
		       ";


       long t[] = {	0xa1,0xa7,0xa8,0xbc,0xbd,0xc1,0xc3,0xc4,0xc5,
	       		0xcc,0xcd,0xce,0xcf,0xd0,0xd1,0xd2,0xd3,0xd4,
			0xd5,0xd6,0xd7,0xd8,0xd9,0xda,0xdb,0xdd,0xe0,
			0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xa2,0xa3,0xc6,
			0xc7,0xc8,0xc9,0xaa,0xab,0xac,0xad,0xa1,0xa3,
			0xa5,0xa7,0xa9,0xc3,0xe3,0xe5,0xe7,0xee,0xc3,0xa1,
			0xa5,0xa7,0xa9,0xc3,0xe3,0xee,0xe7,0xf5,0xf6,
			0xca,0xcb					};


	if( (fp = fopen(filename,"w")) == NULL) return -1;

	fprintf(fp,"%s",title);
        fprintf(fp,"\n\n");
        it[0] = 0xa1;
        for(j=0xd6;j<0xda;j++){
                it[1] = j;
                it[2] = '\0';
                fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
        }
       fprintf(fp,"\n\n");
       it[0] = 0xa1;
       for(i = 0; i < 66; i++){
		if(i >= 19 && i <= 22) continue;

		if( (i >= 0 && i <= 31) || (i == 64) || (i == 65) ){
			it[1] = t[i];
		        it[2] = '\0';
		        fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);

		}

	}
        fprintf(fp,"\n\n");
        it[0] = 0xa2;
        for(i = 39; i < 43; i++){
		it[1] = t[i];
                it[2] = '\0';
                fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
        }
        fprintf(fp,"\n\n");
        it[0] = 0xa8;
        for(j = 0xa0; j <= 0xbc; j++){
                it[1] = j;
                it[2] = '\0';
                fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
        }
        fprintf(fp,"\n\n");
        it[0] = 0xa1;
        for(i = 33; i < 35; i++){
		it[1] = t[i];
	        it[2] = '\0';
	        fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
	}
        fprintf(fp,"\n\n");
	it[0] = 0xa1;
        for(i = 35; i < 39; i++){
                it[1] = t[i];
                it[2] = '\0';
                fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
        }
        fprintf(fp,"\n\n");
        it[0] = 0xa4;
        for(i = 43; i < 53; i++){
                it[1] = t[i];
                it[2] = '\0';
                fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
        }
        fprintf(fp,"\n\n");
        it[0] = 0xa5;
        for(i = 53; i < 64; i++){
                it[1] = t[i];
                it[2] = '\0';
                fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
        }
	fprintf(fp,"\n\n");

	fclose(fp);

	return 0;
}

