#include "itext.h"
#include "xtext.h"
#include "xjp.h"

#if HAVE_LIBIMLIB

#include <X11/extensions/shape.h>
#include <Imlib.h>

#endif

extern XImage *bimg;

static image_data_t * _image_data_alloc()
{
	image_data_t *im;
	if((im = (image_data_t *)malloc(sizeof(image_data_t))) != NULL)

		im->flag = 0;
	return im;
}
static void * _image_data_add(image_data_t **head,image_data_t **tail,image_data_t *im)
{
        if(*tail){
                im->next = NULL;
                im->prev = *tail;

                (*tail)->next = im;
                *tail = im;
        }else{
                im->next = NULL;
                im->prev = NULL;

                *tail = im;
                *head = im;
        }
	return NULL;
}
static int _xtext_max_wh(      Display *disp,
                        	my_window_t *win,
                        	char_data_t *char_d,
                        	ITEXT_T *it,
                        	int *xmax,
                        	int *ymax,
 				int *wmax,
				int *hmax		)
{
        Pixmap pix;
        XImage *im;
	XGCValues gval;

        XFontSet fs;
        GC gc;
	XRectangle ink,log;
        unsigned char temp[3];
        unsigned long pixel;
        int x,y,xpos,ypos,charSize;
        int x_min=9999,y_min=9999,x_max=0,y_max=0,w,h;


	if( ChFlag(it->flag,_EJC) ){
		temp[0] = it->c1;
		temp[1] = it->c2;
		temp[2] = '\0';
        	fs = win->fs;
        	charSize = char_d->charSize;
	}else{
		temp[0] = it->c1;
		temp[1] = '\0';
        	fs = win->fs_e;
        	charSize = char_d->charSize_e;
	}

        if(ChFlag(it->flag,_SML)){
		fs = win->fs_s;
                charSize = char_d->charSize_s;
        }

	gc = win->black_gc;

	/*
	XGetGCValues(disp,gc,GCForeground,&gval);
	XGetGCValues(disp,gc,GCBackground,&gval);
	printf("%d\n",gval.foreground);
	*/
	gval.foreground = 0xffff;
	XChangeGC(disp,gc,GCForeground,&gval);
        pix = XCreatePixmap(disp,DefaultRootWindow(disp),charSize,charSize,DefaultDepth(disp,0));
        XFillRectangle(disp,pix,gc,0,0,charSize,charSize);

	gval.foreground = 0x0000;
	XChangeGC(disp,gc,GCForeground,&gval);
	XmbTextExtents(fs,(char *)temp,strlen((char *)temp),&ink,&log);
        xpos = log.x; 
        ypos = 0 - log.y;
        XmbDrawString(disp,pix,fs,gc,xpos,ypos,(char *)temp,strlen((char *)temp));
        im = XGetImage(disp,pix,0,0,charSize,charSize,AllPlanes,XYPixmap);

        for(x=0;x<charSize;x++){
                for(y=0;y<charSize;y++){
                        pixel = XGetPixel(im,x,y);
                        if( pixel == 0x0000){
				if( x <= x_min ) x_min = x;
				if( x >= x_max ) x_max = x;
				if( y <= y_min ) y_min = y;
				if( y >= y_max ) y_max = y;
                        }
                }
        }
	w = x_max - x_min;
	h = y_max - y_min;	

	*xmax = x_min - xpos + 1; 
	*ymax = ypos - y_max + 1;
	*wmax = w; 
	*hmax = h;	

        if(im) XDestroyImage(im);
        if(pix) XFreePixmap(disp,pix);

	/*
	printf("gbal ( %s ): x0:%d x1:%d y0:%d y1:%d\n",temp,x_min,x_max,y_min,y_max);
	printf("ink:%d %d log:%d %d\n",ink.x,ink.y,log.x,log.y);
	*/
	
        return 0;
}
static Pixmap _xtext_Draw_imageString_normal(	Display *disp,
						my_window_t *win,
						char_data_t *char_d,
						ITEXT_T *it,
						int type,
						XImage **base_im	)
{
        Pixmap pix;
	int charSize;
        int tx,ty;
	int myw,myh,myx,myy;

	XFontSet fs;
	GC gc,gc1;
	unsigned char text[3];

	fs = win->fs;
	gc1 = win->sgc;
	gc = win->gc;
	charSize = char_d->charSize;
	text[0] = it->c1;
	text[1] = it->c2;
	text[2] = '\0';

	if(ChFlag(it->flag,_CHU)){
	       	gc = win->rubi_gc;
	}
	if(ChFlag(it->flag,_SML)){
	       	charSize = char_d->charSize_s;
		fs = win->fs_s;
	}
	if( !ChFlag(it->flag,_EJC) ){
		charSize = char_d->charSize_e;
		fs = win->fs_e;
		text[0] = it->c1;
		text[1] = '\0';
	}

        pix = XCreatePixmap(disp,DefaultRootWindow(disp),charSize,charSize,DefaultDepth(disp,0));
	/* test  
        XFillRectangle(disp,pix,win->find_gc,0,0,charSize,charSize);
	 ---- */
        XFillRectangle(disp,pix,win->bgc,0,0,charSize,charSize);
        *base_im = XGetImage(disp,pix,0,0,charSize,charSize,AllPlanes,XYPixmap);
	_xtext_max_wh(disp,win,char_d,it,&myx,&myy,&myw,&myh);

	if(ChFlag(it->flag,_EJC)){

		if(type == 4){
			/*
			printf("( %s ) : %d  %d (%d %d)\n",text,myw,myh,myx,myy);
			*/
			tx = charSize - myw - myx - 1;
			ty = myh + myy;

		}else if(type == 3){
			tx = 0 - myx + myw + (charSize/4);
			ty = myh + myy;
		}else if(type == 5){
			tx = 0 - myx + 2;
			ty = charSize -  myy - 2;

		}else if(type == 0){
			tx = (charSize - myw) / 2 - myx + 1;
			ty = charSize - (charSize - myh) / 2 + myy - 1;

		}else if(type == 6){
			tx = (charSize - myw) / 2 - myx - 2;
			ty = charSize - (charSize - myh) / 2 + myy;

		}else if(type == 1){
			tx = (charSize / 2) - (myw + myx);
			ty = charSize - myy - (charSize/4);

		}else{
			fprintf(stderr,"No type : %s %d\n",text,myy);
			tx = myx;
			ty = myh + myy;
		}
		XmbDrawString(disp,pix,fs,gc,tx,ty,(char *)text,strlen((char *)text));
	}else{
		tx = (charSize - myw) / 2 - myx;
		ty = charSize - (charSize - myh) / 2 + myy;
		XmbDrawString(disp,pix,fs,gc,tx,ty,(char *)text,strlen((char *)text));
	}

	return pix;
}
static Pixmap _xtext_Draw_imageString_anti(	Display *disp,
						my_window_t *win,
						char_data_t *char_d,
						ITEXT_T *it,
						int type,
						XImage **base_im	)
{
	Pixmap pix;
	int charSize;

#if HAVE_LIBXFT

	XGlyphInfo gi;

	XftDraw *draw = NULL;
	XftFont *font = NULL;
	XftColor color;

	unsigned char text[3];
	char utf8[8];
	int tx,ty;

	font = win->font;
	color = win->fg_color;
	charSize = char_d->charSize;

	if(ChFlag(it->flag,_CHU)) color = win->rubi_color;
	if(ChFlag(it->flag,_FND)) color = win->find_color;

	if(ChFlag(it->flag,_SML)){
	       	font = win->font_s;
		charSize = char_d->charSize_s;
	}
	if( !ChFlag(it->flag,_EJC)){
	       	font = win->font_e;
		charSize = char_d->charSize_e;
	}

        if((pix = XCreatePixmap(disp,DefaultRootWindow(disp),charSize,charSize,DefaultDepth(disp,0))) <= 0){ 
		fprintf(stderr,"Error:CreatePixmap() xtext_f9.c(229)\n");
		return -1;
	}

	/* -- test --   
        XFillRectangle(disp,pix,win->find_gc,0,0,charSize,charSize);
	  ----------- */
        XFillRectangle(disp,pix,win->bgc,0,0,charSize,charSize);
        *base_im = XGetImage(disp,pix,0,0,charSize,charSize,AllPlanes,XYPixmap);
	draw = XftDrawCreate(disp,pix,win->visual,win->cmap);

	if(ChFlag(it->flag,_EJC)){

		text[0] = it->c1; text[1] = it->c2; text[2] = '\0';

		euc2utf8_c(XJP_CONV,utf8,(char *)text,2);
		XftTextExtentsUtf8(disp,font,(FcChar8 *)utf8,strlen(utf8),&gi);

		if(type == 4){
			tx = charSize - gi.width + gi.x - 1;
			ty = (charSize - gi.height) / 2 + gi.y; 

		}else if(type == 3){
			tx = ((charSize - gi.width) / 2) + gi.x + (charSize/4);
			ty = ((charSize - gi.height) / 2) + gi.y - 1;
		}else if(type == 5){
			tx = 1;
			ty = ((charSize - gi.height) / 2) + gi.y + 2;

		}else if(type == 6){
			tx = (charSize - gi.width) / 2 + gi.x;
			ty = ((charSize - gi.height) / 2) + gi.y;

		}else if(type == 0){
			tx = ((charSize - gi.width) / 2) + gi.x;
			ty = ((charSize - gi.height) / 2) + gi.y + 2;

		}else if(type == 1){
			tx = charSize / 2 - gi.width + gi.x - 1;
			ty = charSize - gi.height + 1;

		}else{
			fprintf(stderr,"No type : %s,%d \n",text,gi.y);
			tx = gi.x;
			ty = gi.y;
		}
			
		XftDrawStringUtf8(draw,&color,font,tx,ty,(FcChar8 *)utf8,strlen(utf8));
	}else{

		text[0] = it->c1;
		text[1] = '\0';
		XftTextExtentsUtf8(disp,font,(FcChar8 *)text,strlen((char *)text),&gi);
		/*
		printf("( %s ): %d %d %d %d\n",text,gi.x,gi.y,gi.width,gi.height);
		*/
		tx = (charSize - gi.width) / 2 + gi.x;
		ty = (charSize - (charSize - gi.height) / 2) - (gi.height - gi.y);
		XftDrawString8(draw,&color,font,tx,ty,text,strlen((char *)text));
	}

	XftDrawDestroy(draw);

	return pix;
#else
	pix = _xtext_Draw_imageString_normal(disp,win,char_d,it,type,base_im);
	return pix;
#endif
}
static XImage * get_string_image(      	Display *disp,
                                	my_window_t *win,
					char_data_t *char_d,
					ITEXT_T *it,
                                	int type        )
{
	int charSize;

	Pixmap pix;
        XImage *base_im,*char_im;

        long pixel;
        int x,y;
        int x0,x1,y0,y1;

	if(win->anti == 0){
		pix = _xtext_Draw_imageString_normal(disp,win,char_d,it,type,&base_im);

	}else{
		pix = _xtext_Draw_imageString_anti(disp,win,char_d,it,type,&base_im);
	}
	charSize = char_d->charSize;

	if( !ChFlag(it->flag,_EJC) ) charSize = char_d->charSize_e;
	if(ChFlag(it->flag,_SML)) charSize = char_d->charSize_s;

        char_im = XGetImage(disp,pix,0,0,charSize,charSize,AllPlanes,XYPixmap);

	if(type == 0){ 
		x0 = 0; x1=charSize; 
		y0 = 0; y1=charSize;

	}else if(type == 1){ 
		x0=0; x1=charSize/2; 
		y0=charSize/2; y1=charSize;

	}else if(type == 2){ 
		x0=0; x1=charSize; 
		y0=0; y1=charSize/2;

	}else if(type == 3 || type == 5 || type == 6){ 
		x0 = 0; x1=charSize; 
		y0 = 0; y1=charSize;

	}else if(type == 4){ 
		x0=0; x1=charSize; 
		y0=0; y1=charSize;
	}else{
		x0=0; x1=charSize; 
		y0=0; y1=charSize;
	}

        for(x=x0;x<x1;x++){
                for(y=y0;y<y1;y++){
                        pixel = XGetPixel(char_im,x,y);

                        if(type == 0){
                                XPutPixel(base_im,charSize-y,x,pixel);

                        }else if(type == 1){
                                XPutPixel(base_im,x+charSize/2,y-charSize/2,pixel);

                        }else if(type == 2){
                                XPutPixel(base_im,x,charSize/2+y,pixel);

                        }else if(type == 3 || type == 5 || type == 6){
                                XPutPixel(base_im,charSize-y,x,pixel);

                        }else if(type == 4){
                                XPutPixel(base_im,x,y,pixel);
                        }else{
                                XPutPixel(base_im,x,y,pixel);
			}

                }
        }
        XFreePixmap(disp,pix);

	/* -- test code ----- */ 
	if(type == 16 || type == 10) return char_im;
	/* ------------------ */

        XDestroyImage(char_im);

        return base_im;
}
void xtext_image_data_free(image_data_t **head,image_data_t **tail)
{
	image_data_t *im,*imm;

	for(im = *head;im!=NULL;im=imm){

		imm = im->next;
		XDestroyImage(im->char_image);
		free(im);

	}

	*head = NULL;
	*tail = NULL;

	return;
}
void xtext_image_data_insert(	Display *disp,
				my_window_t *win,
				char_data_t *char_d,
				ITEXT_T *it,
				int type		)
{
	image_data_t *im;
	int s_type;

	if(char_d->charSize <= 0) return;

	if(char_d->im_head != NULL){
		for(im=char_d->im_head;im!=NULL;im=im->next){
			if(	im->c1 == it->c1 	&& 
				im->c2 == it->c2 	&& 
				ChFlag(im->flag,_CHU) == ChFlag(it->flag,_CHU)	&& 
				ChFlag(im->flag,_SML) == ChFlag(it->flag,_SML) 	&&
				ChFlag(im->flag,_FND) == ChFlag(it->flag,_FND)   ) break;
		}
		if(im != NULL) return ;
	}

	im = _image_data_alloc();
	im->c1 = it->c1; im->c2 = it->c2;

	if(ChFlag(it->flag,_CHU))
		OnFlag(im->flag,_CHU);
	else
		OfFlag(im->flag,_CHU);

	if(ChFlag(it->flag,_SML))
		OnFlag(im->flag,_SML);
	else
		OfFlag(im->flag,_SML);

	if(ChFlag(it->flag,_FND))
		OnFlag(im->flag,_FND);
	else
		OfFlag(im->flag,_FND);

	if(type == 1) s_type = 0;
	if(type == 2) s_type = 1;
	if(type == 3) s_type = 2;
	if(type == 4) s_type = 3;
	if(type == 5) s_type = 4;
	if(type == 6) s_type = 5;
	if(type == 7) s_type = 6;

	im->char_image = (XImage *)get_string_image(disp,win,char_d,it,s_type);
	_image_data_add(&char_d->im_head,&char_d->im_tail,im);

	return;
}
int xtext_check_image_data(ITEXT_T *it)
{
        if( !ChFlag(it->flag,_EJC) ) return 1;

        if(it->c1 == 0xa1){

		if( it->c2 >= 0xd6 && it->c2 <= 0xd9){
			if( (it->c2 - 0xd6) % 2)
		       		return 6;
			else
				return 4;
		}
		if( it->c2 >= 0xca && it->c2 <= 0xd5 ){
			if( (it->c2 - 0xca) % 2 )
				return 7;
			else
				return 1;
		}
		if( it->c2 == 0xdb ) return 7;
		if( it->c2 == 0xda ) return 1;

                switch(it->c2){
			case 0xa1:
                        case 0xa7:case 0xa8:
                        case 0xbc:case 0xbd:
                        case 0xc1:case 0xc3:case 0xc4:case 0xc5:
                        case 0xdd:
			case 0xe0:case 0xe1:case 0xe2:case 0xe3:
			case 0xe4:case 0xe5:case 0xe6:
				return 1;
                        break;

                        case 0xa2:case 0xa3:
                                return 2;
                        break;

                        case 0xc6:case 0xc7:
                        case 0xc8:case 0xc9:
                                return 4;
                        break;

		}
        }else if(it->c1 == 0xa2){
                switch(it->c2){
                        case 0xaa:case 0xab:case 0xac:case 0xad:
                                return 1;
                        break;
                }
        }else if(it->c1 == 0xa8){
                if(it->c2 >= 0xa0 && it->c2 <= 0xbc){
	                        return 1;
                }

        }else if(it->c1 == 0xa4){
                switch(it->c2){
                        case 0xa1:case 0xa3:case 0xa5:case 0xa7:case 0xa9:
                        case 0xe3:case 0xe5:case 0xe7:case 0xee:case 0xc3:
                                return 5;
                        break;
                }
        }else if(it->c1 == 0xa5){
                switch(it->c2){
                        case 0xa1:case 0xa3:case 0xa5:case 0xa7:case 0xa9:
                        case 0xc3:case 0xe3:case 0xee:case 0xe7:case 0xf5:case 0xf6:
                                return 5;
                        break;
                }
	}

        return 0;
}
XImage * xtext_get_bimage(Display *disp,my_window_t *win,char_data_t *char_d)
{
	Pixmap pix;
	XImage *base_im,*im,*bim;
	unsigned long pixel;
	unsigned char c1 = 0xa1,c2 = 0xa2;

	ITEXT_T *it;

	int charSize;
	int x,y,w,h;
	int xmin=9999,xmax=0,ymin=9999,ymax=0;


	it = (ITEXT_T *)malloc(sizeof(ITEXT_T));
	it->c1 = c1;
	it->c2 = c2;
	it->flag = 0;
	it->off = 0;

	OnFlag(it->flag,_EJC);
	OfFlag(it->flag,_CHU);
	OfFlag(it->flag,_SML);

	if(win->anti == 0){
		pix = _xtext_Draw_imageString_normal(disp,win,char_d,it,1,&base_im);

	}else{
		pix = _xtext_Draw_imageString_anti(disp,win,char_d,it,1,&base_im);
	}

	charSize = char_d->charSize;
        im = XGetImage(disp,pix,0,0,charSize,charSize,AllPlanes,XYPixmap);

        for(x=0;x<charSize;x++){
                for(y=0;y<charSize;y++){
                        pixel = XGetPixel(im,x,y);
                        if(win->bg_pixel != pixel){

                                if(x < xmin) xmin = x;
				if(x >= xmax) xmax = x;

				if(y < ymin) ymin = y;
				if(y >= ymax) ymax = y;

                        }
                }
        }
	if((w = xmax - xmin) < 0) return NULL;
	if((h = ymax - ymin) < 0) return NULL;

	if(( xmin + (w+2) ) <= charSize){
		w += 2;
	}

	h = charSize - ymin;
        bim = XGetImage(disp,pix,xmin,ymin,w,h,AllPlanes,XYPixmap);

	free(it);
        if(im) XDestroyImage(im);
	if(base_im) XDestroyImage(base_im);
        if(pix) XFreePixmap(disp,pix);

	return bim;
}
int xtextDrawArc(	Display *disp,
			my_window_t *win,
			int x0,
			int y0,
			int x1,
			int y1,
			int type		)
{
	Drawable draw;
	XPoint point[4];
	int w,h;

	draw = win->pix0;

	switch(type){
		case 0:case 1:
			if(bimg != NULL)
				XPutImage(disp,draw,win->gc,bimg,0,0,x0,y0+(y1-y0)/2,bimg->width,bimg->height);
		break;
		case 2:
			w = (x1 - x0) - 3;
			h = w;
			XFillArc(disp,draw,win->gc,x0,y0+((y1-y0)-h)/2,w,h,0,360*64);
		break;
		case 3:
			w = (x1 - x0) - 3;
			h = w;
			XDrawArc(disp,draw,win->gc,x0,y0+((y1-y0)-h)/2,w,h,0,360*64);
		break;
		case 4:
			w = (x1 - x0);
			h = w;

			point[0].x = x0 + w/2;
			point[0].y = y0 + h/4;
			point[1].x = x0;
			point[1].y = y1 - h/4;
			point[2].x = x1;
			point[2].y = y1 - h/4;
			point[3].x = x0 + w/2;
			point[3].y = y0 + h/4;

			XFillPolygon(disp,draw,win->gc,point,4,Complex,CoordModeOrigin);

		break;
		case 5:
			w = (x1 - x0);
			h = w;

			point[0].x = x0 + w/2;
			point[0].y = y0 + h/4;
			point[1].x = x0;
			point[1].y = y1 - h/4;
			point[2].x = x1;
			point[2].y = y1 - h/4;
			point[3].x = x0 + w/2;
			point[3].y = y0 + h/4;

			XDrawLines(disp,draw,win->gc,point,4,CoordModeOrigin);
		break;
		case 6:
			w = (x1 - x0) - 1;
			h = w;
			XDrawArc(disp,draw,win->gc,x0,y0+((y1-y0)-h)/2,w,h,0,360*64);

			w = (x1 - x0) - 5;
			h = w;
			XDrawArc(disp,draw,win->gc,x0 + 2,y0+((y1-y0)-h)/2,w,h,0,360*64);
		break;
		case 7:
			w = (x1 - x0) - 1;
			h = w;
			XDrawArc(disp,draw,win->gc,x0,y0+((y1-y0)-h)/2,w,h,0,360*64);

			w = (x1 - x0) - 5;
			h = w;
			XFillArc(disp,draw,win->gc,x0 + 2,y0+((y1-y0)-h)/2,w,h,0,360*64);
		break;

	}

	return 0;
}
int xtextDrawLine(	Display *disp,
			my_window_t *win,
			int x0,
			int y0,
			int x1,
			int y1,
			int type		)
{
	Drawable draw;
	XSegment seg[2]; 
	XArc arc[10];
	int i,p,w,h;

	if(win == NULL) return -1;

	draw = win->pix0;

	switch(type){
		case 0:
			p = 2;

			seg[0].x1 = x0;
			seg[0].y1 = y0;
			seg[0].x2 = x1;
			seg[0].y2 = y1;

		       	seg[1].x1 = x0+p;
			seg[1].y1 = y0;
			seg[1].x2 = x1+p;
			seg[1].y2 = y1;

			XDrawSegments(disp,draw,win->gc,seg,2);
		break;
		case 1:
			p = y0;
			for(i=0;;i++){
				if((p += 2) >= y1) break;
				if((i % 2) == 0){
					XDrawLine(disp,draw,win->gc,x0,p,x1,p+2);
				}
			}
		break;
		case 2:
			p = y0;
			for(i=0;;i++){
				if((p += 4) >= y1) break;
				if((i % 2) == 0){
					XDrawLine(disp,draw,win->gc,x0,p,x1,p+4);
				}
			}
		break;
		case 3:
			w = 2;
			h = 4;

			for(i=0;;i++){
				if(y1 <= (y0 + (i * h))) break;
				arc[i].x = x0;
				arc[i].y = y0 + (i * h);
				arc[i].width = w;
				arc[i].height = h;
				if(i % 2 == 0){
					arc[i].angle1 = 90 * 64;
					arc[i].angle2 = 180 * 64;
				}else{
					arc[i].angle1 = 270 * 64;
					arc[i].angle2 = 180 * 64;
				}
			}
			XDrawArcs(disp,draw,win->gc,arc,i);
		break;
		default:
			XDrawLine(disp,draw,win->gc,x0,y0,x1,y1);
		break;
	}

	return 0;
}
int xtextDrawFrame(Display *disp,Window win,GC gc0,int width,int height,int type)
{
	GC gc;
	XPoint point[3][3];
	int mode = CoordModeOrigin; 

	gc = gc0;

	point[0][0].x = width - 0;
	point[0][0].y = 0;
	point[0][1].x = 0;
	point[0][1].y = 0;
	point[0][2].x = 0;
	point[0][2].y = height - 0;

	point[1][0].x = 0;
	point[1][0].y = height - 1;
	point[1][1].x = width - 1;
	point[1][1].y = height - 1;
	point[1][2].x = width - 1;
	point[1][2].y = 0;

	point[2][0].x = 1;
	point[2][0].y = height - 2;
	point[2][1].x = width - 2;
	point[2][1].y = height - 2;
	point[2][2].x = width - 2;
	point[2][2].y = 1;

	if(type == 0){
		XSetForeground(disp,gc,WhitePixel(disp,0));
		XDrawLines(disp,win,gc,point[0],3,mode);
		XSetForeground(disp,gc,BlackPixel(disp,0));
		XDrawLines(disp,win,gc,point[1],3,mode);
		XDrawLines(disp,win,gc,point[2],3,mode);
	}else{
		XSetForeground(disp,gc,BlackPixel(disp,0));
		XDrawLines(disp,win,gc,point[0],3,mode);
		XSetForeground(disp,gc,WhitePixel(disp,0));
		XDrawLines(disp,win,gc,point[1],3,mode);
	}

	return 0;
}


